use strict; use warnings;

my $version='0.4';

$main::preferences{"FreeStyleWiki Syntax Emulator $version"} = [
    { desc=>'Enable: {{...}} style plugin' ,
      name=>'fswiki__bresscommand' ,
      type=>'checkbox' } ,

    { desc=>'Enable: Indent-style verbatim' ,
      name=>'fswiki__verbindent' ,
      type=>'checkbox' } ,
    
    { desc=>'Enable: CSV-style table block' ,
      name=>'fswiki__table' ,
      type=>'checkbox' } ,

    { desc=>'Enable: Titleline without pre/post-blanklines' ,
      name=>'fswiki__onemdashi' ,
      type=>'checkbox' } ,

    { desc=>'Change: Two and three colons-style definition' ,
      name=>'fswiki__definition' ,
      type=>'checkbox' } ,
];

### Command plugin {{...}} ###
if( $main::config{fswiki__bresscommand} ){
    $main::inline_syntax_plugin{'800_plugin'} = sub{
       ${$_[0]} =~ s/(?:\{\{|\(\()(.+?)(?:\}\}|\)\))/&plugin($_[1],$1)/ges;
    };
}

### Verbatim by Indented block ###
if( $main::config{fswiki__verbindent} ){
    $main::block_syntax_plugin{'001_verb'} = sub {
       my ($fragment,$session)=@_;
       return 0 if $fragment =~ /^\S/m || $fragment !~ /^\s/m;

       &puts("\n\n<pre>".&verb($fragment)."</pre>\n\n");
       1;
    };
}

### Definition block ###
if( $main::config{fswiki__definition} ){
    $main::block_syntax_plugin{'200_definition'} = sub {
       my ($fragment,$session)=@_;
       return 0 unless $fragment =~ /\A\s*\:/;

       my @s=split(/\n\s*:/, &preprocess($',$session) );
       &puts('<dl>',
           map( /^::/ ? "<dd>$'</dd>\r\n"
              : /^:/  ? "<dt>$'</dt>\r\n"
              : /:/   ? "<dt>$`</dt><dd>$'</dd>\r\n"
              : "<dt>$_</dt>"
              , @s ),'</dl>');
       1;
    };
}

### Table bock ###
if( $main::config{fswiki__table} ){
    $main::block_syntax_plugin{'701_table'} = sub {
       my ($fragment,$session)=@_;
       return 0 unless $fragment =~ /\A,/;

       my $i=0;
       &puts('<table>');
       foreach my $tr ( split(/\n,/s,&preprocess($',$session) ) ){
           my $tag=($i == 0 ? 'th' : 'td');
           &puts( '<tr class="'.(++$i % 2 == 0 ? "odd":"even").'">',
                  map("<$tag>$_</$tag>",split(/,/,$tr) ) , '</tr>' );
       }
       &puts('</table>');
       1;
    };
}

### Disable {{category}} ###
$main::inline_plugin{'category'} ||= sub{
   "<p>Category=" . $_[0]->{argv} ."</p>";
};

### {{ref}} {{ref_image}} ###
$main::inline_plugin{'ref'} =
$main::inline_plugin{'ref_image'} = sub{
   my ($session,$nm)=@_;
   my $attachment = $session->{attachment};
   exists $attachment->{$nm}
   ? $session->{attachment}->{$nm}->{tag} : "<blink>$nm</blink>";
};

### 1-line midashi ###
if( $main::config{fswiki__onemdashi} ){
    $::call_syntax_plugin{'200_fswiki_midashi'} = sub {
	my ($html)=(@_);
	$$html =~ s/^\s*(\!.*?)\s*$/\r\n$1\r\n/gm;
    };
}
1;
